# Participant Preparation
## Marker
Before performing the experiments, the participants should be prepared with 
a marker. This can either be a colored hat / beanie 
([multicolor marker](/recognition/multicolor.md)) alone or in combination with an
individual marker ([code marker](/recognition/aruco.md)).
The multicolor marker is easy to prepare and works even with low resolution
cameras. The code marker is minimally more work to prepare, but it will 
enable you to link individual information via a markerID to the participants and 
facilitate the tracking process.
If the recording of individual information is wanted, it should be done 
through a questionnaire that participants fill out before the experiments 
(e.g. age, gender). The code marker should remain identical throughout the 
entire experiment in order to analyze individuals across experiments.

:::{Important}
To ensure that your experimental setup, including camera height and camera settings, enables you to detect markers, test your chosen setup in [PeTrack](/recognition/recognition.md) beforehand. For this test of the recognition, no calibration is needed.
:::

## Clothing

Care must be taken to ensure that the clothing of the participants does not 
influence the recognition of markers or their elements.
In particular, colors of markers should not appear in the clothing. Shirts can
be provided if participants are nevertheless wearing unfavorable colors.

## Height
The greater the difference in the height of the participants, the greater the 
occlusion, so that it may make sense to limit the participant acquisition to a 
specific height range.
When the participants' height (with shoes!) is measured, it can later be 
imported into PeTrack and improve the overall data accuracy. 


:::{Note}
During the filming of the experiments, only the participating people should be
inside the camera view. This is especially important for people wearing 
markers! 
:::
