# Surrounding

For camera recordings, as much **light** as possible from above is important for
a clear, sharp image. The light should be as bright as possible without
influencing the experiment. It must also not affect the colors and must match
the shutter speed of the camera. Low shutter speeds of the camera that are not
synchronized with the light can lead to a pumping of the brightness. The light
should illuminate the entire scene locally (so that tracking does not get stuck
at hard shadows) and globally (so that parameters for marker recognition can be
set more precisely) in a uniformly diffuse manner. Only artificial light without
daylight coming in through windows should be used in order to keep the
brightness constant during the experiment and in particular to avoid hard
shadows. If photos are to be taken during the experiments, then only without
flash light.

Care must be taken to ensure that **clothing** does not influence the
recognition of markers or their elements. In particular, colors of markers
should not appear in the clothing. This should be clearly stated when
communicating with the participants right before the experiments. Overshirts can
be provided if test subjects are nevertheless wearing unfavorable clothing.

What is true for the clothing also counts for the **superstructures** and the *
*floor**. In addition to avoiding marker colors, care must also be taken to
ensure that the surfaces are not reflective, as otherwise people may be
incorrectly recognized or errors may occur in the disparity calculation of the
stereo cameras. In addition, strong contrasts, e.g. due to adhesive strips,
should be avoided as the tracking could get stuck there.

During the filming of the experiments, only the participating people should be
inside the experimental area.

<!-- **Not involved persons** should be stand away from the experimental area, otherwise their feet will be seen in the head height of the experimental area caused by the perspective view of the cameras. For used wide angle lenses this has to be at least 3 meters. -->
